Index: src/Actions/MapOfActions.cpp
===================================================================
--- src/Actions/MapOfActions.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MapOfActions.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,11 +6,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 using namespace std;
 
+#include "Actions/MapOfActions.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "Descriptors/MoleculeIdDescriptor.hpp"
+#include "Helpers/Assert.hpp"
 #include "Patterns/Singleton_impl.hpp"
-#include "Actions/MapOfActions.hpp"
-#include "Helpers/Assert.hpp"
 
 #include <boost/lexical_cast.hpp>
@@ -18,15 +25,28 @@
 #include <boost/program_options.hpp>
 
+#include <iostream>
+
+#include "atom.hpp"
+#include "Box.hpp"
 #include "CommandLineParser.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "element.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "molecule.hpp"
+#include "periodentafel.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
 
 #include "Actions/ActionRegistry.hpp"
 #include "Actions/AnalysisAction/MolecularVolumeAction.hpp"
 #include "Actions/AnalysisAction/PairCorrelationAction.hpp"
+#include "Actions/AnalysisAction/PointCorrelationAction.hpp"
 #include "Actions/AnalysisAction/PrincipalAxisSystemAction.hpp"
+#include "Actions/AnalysisAction/SurfaceCorrelationAction.hpp"
 #include "Actions/AtomAction/AddAction.hpp"
 #include "Actions/AtomAction/ChangeElementAction.hpp"
 #include "Actions/AtomAction/RemoveAction.hpp"
+#include "Actions/AtomAction/RotateAroundOriginByAngleAction.hpp"
+#include "Actions/AtomAction/TranslateAction.hpp"
 #include "Actions/CmdAction/BondLengthTableAction.hpp"
 #include "Actions/CmdAction/ElementDbAction.hpp"
@@ -42,4 +62,5 @@
 #include "Actions/MoleculeAction/FillWithMoleculeAction.hpp"
 #include "Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp"
+#include "Actions/MoleculeAction/RotateAroundSelfByAngleAction.hpp"
 #include "Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp"
 #include "Actions/MoleculeAction/SaveAdjacencyAction.hpp"
@@ -47,8 +68,29 @@
 #include "Actions/MoleculeAction/SaveTemperatureAction.hpp"
 #include "Actions/MoleculeAction/SuspendInWaterAction.hpp"
-#include "Actions/MoleculeAction/TranslateAction.hpp"
 #include "Actions/MoleculeAction/VerletIntegrationAction.hpp"
 #include "Actions/ParserAction/LoadXyzAction.hpp"
 #include "Actions/ParserAction/SaveXyzAction.hpp"
+#include "Actions/SelectionAction/AllAtomsAction.hpp"
+#include "Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp"
+#include "Actions/SelectionAction/AllAtomsInsideSphereAction.hpp"
+#include "Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp"
+#include "Actions/SelectionAction/AllMoleculesAction.hpp"
+#include "Actions/SelectionAction/AtomByElementAction.hpp"
+#include "Actions/SelectionAction/AtomByIdAction.hpp"
+#include "Actions/SelectionAction/ClearAllAtomsAction.hpp"
+#include "Actions/SelectionAction/ClearAllMoleculesAction.hpp"
+#include "Actions/SelectionAction/MoleculeByFormulaAction.hpp"
+#include "Actions/SelectionAction/MoleculeByIdAction.hpp"
+#include "Actions/SelectionAction/MoleculeOfAtomAction.hpp"
+#include "Actions/SelectionAction/NotAllAtomsAction.hpp"
+#include "Actions/SelectionAction/NotAllAtomsInsideCuboidAction.hpp"
+#include "Actions/SelectionAction/NotAllAtomsInsideSphereAction.hpp"
+#include "Actions/SelectionAction/NotAllAtomsOfMoleculeAction.hpp"
+#include "Actions/SelectionAction/NotAllMoleculesAction.hpp"
+#include "Actions/SelectionAction/NotAtomByElementAction.hpp"
+#include "Actions/SelectionAction/NotAtomByIdAction.hpp"
+#include "Actions/SelectionAction/NotMoleculeByFormulaAction.hpp"
+#include "Actions/SelectionAction/NotMoleculeByIdAction.hpp"
+#include "Actions/SelectionAction/NotMoleculeOfAtomAction.hpp"
 #include "Actions/TesselationAction/ConvexEnvelopeAction.hpp"
 #include "Actions/TesselationAction/NonConvexEnvelopeAction.hpp"
@@ -60,5 +102,4 @@
 #include "Actions/WorldAction/InputAction.hpp"
 #include "Actions/WorldAction/OutputAction.hpp"
-#include "Actions/WorldAction/RemoveSphereOfAtomsAction.hpp"
 #include "Actions/WorldAction/RepeatBoxAction.hpp"
 #include "Actions/WorldAction/ScaleBoxAction.hpp"
@@ -131,8 +172,8 @@
   }
   BV.xx = boost::lexical_cast<double>(components.at(0));
-  BV.xy = boost::lexical_cast<double>(components.at(1));
-  BV.xz = boost::lexical_cast<double>(components.at(2));
-  BV.yy = boost::lexical_cast<double>(components.at(3));
-  BV.yz = boost::lexical_cast<double>(components.at(4));
+  BV.yx = boost::lexical_cast<double>(components.at(1));
+  BV.yy = boost::lexical_cast<double>(components.at(2));
+  BV.zx = boost::lexical_cast<double>(components.at(3));
+  BV.zy = boost::lexical_cast<double>(components.at(4));
   BV.zz = boost::lexical_cast<double>(components.at(5));
   v = boost::any(BoxValue(BV));
@@ -161,4 +202,6 @@
   DescriptionMap["change-element"] = "change the element of an atom";
   DescriptionMap["change-molname"] = "change the name of a molecule";
+  DescriptionMap["clear-atom-selection"] = "clear the atom selection";
+  DescriptionMap["clear-molecule-selection"] = "clear the molecule selection";
   DescriptionMap["convex-envelope"] = "create the convex envelope for a molecule";
   DescriptionMap["default-molname"] = "set the default name of new molecules";
@@ -175,10 +218,13 @@
   DescriptionMap["output"] = "write output files";
   DescriptionMap["set-output"] = "specify output formats";
-  DescriptionMap["pair-correlation"] = "pair correlation analysis between two elements, element and point or element and surface";
+  DescriptionMap["pair-correlation"] = "pair correlation analysis between two elements";
   DescriptionMap["parse-xyz"] = "parse xyz file into World";
+  DescriptionMap["point-correlation"] = "pair correlation analysis between element and point";
   DescriptionMap["principal-axis-system"] = "calculate the principal axis system of the specified molecule";
+  DescriptionMap["redo"] = "redo last action";
   DescriptionMap["remove-atom"] = "remove a specified atom";
-  DescriptionMap["remove-sphere"] = "remove sphere of atoms of around a specified atom";
   DescriptionMap["repeat-box"] = "create periodic copies of the simulation box per axis";
+  DescriptionMap["rotate-origin"] = "rotate selected atoms by a specific angle around origin";
+  DescriptionMap["rotate-self"] = "rotates molecules by a specific angle around own center of gravity";
   DescriptionMap["rotate-to-pas"] = "calculate the principal axis system of the specified molecule and rotate specified axis to align with main axis";
   DescriptionMap["save-adjacency"] = "name of the adjacency file to write to";
@@ -187,14 +233,38 @@
   DescriptionMap["SaveXyz"] = "save world as xyz file";
   DescriptionMap["scale-box"] = "scale box and atomic positions inside";
+  DescriptionMap["select-all-atoms"] = "select all atoms";
+  DescriptionMap["select-all-molecules"] = "select all molecules";
+  DescriptionMap["select-atom-by-element"] = "select an atom by element";
+  DescriptionMap["select-atom-by-id"] = "select an atom by index";
+  DescriptionMap["select-atoms-inside-cuboid"] = "select all atoms inside a cuboid";
+  DescriptionMap["select-atoms-inside-sphere"] = "select all atoms inside a sphere";
+  DescriptionMap["select-molecule-by-id"] = "select a molecule by index";
+  DescriptionMap["select-molecule-by-formula"] = "select a molecule by chemical formula";
+  DescriptionMap["select-molecule-of-atom"] = "select a molecule to which a given atom belongs";
+  DescriptionMap["select-molecules-atoms"] = "select all atoms of a molecule";
   DescriptionMap["set-basis"] = "set the name of the gaussian basis set for MPQC";
   DescriptionMap["set-output"] = "specify output formats";
   DescriptionMap["subgraph-dissect"] = "dissect the molecular system into molecules representing disconnected subgraphs";
+  DescriptionMap["surface-correlation"] = "pair correlation analysis between element and surface";
   DescriptionMap["suspend-in-water"] = "suspend the given molecule in water such that in the domain the mean density is as specified";
-  DescriptionMap["translate-mol"] = "translate molecule by given vector";
+  DescriptionMap["translate-atoms"] = "translate all selected atoms by given vector";
+  DescriptionMap["undo"] = "undo last action";
+  DescriptionMap["unselect-all-atoms"] = "unselect all atoms";
+  DescriptionMap["unselect-all-molecules"] = "unselect all molecules";
+  DescriptionMap["unselect-atom-by-element"] = "unselect an atom by element";
+  DescriptionMap["unselect-atom-by-id"] = "unselect an atom by index";
+  DescriptionMap["unselect-atoms-inside-cuboid"] = "unselect all atoms inside a cuboid";
+  DescriptionMap["unselect-atoms-inside-sphere"] = "unselect all atoms inside a sphere";
+  DescriptionMap["unselect-molecule-by-formula"] = "unselect a molecule by chemical formula";
+  DescriptionMap["unselect-molecule-by-id"] = "unselect a molecule by index";
+  DescriptionMap["unselect-molecule-of-atom"] = "unselect a molecule to which a given atom belongs";
+  DescriptionMap["unselect-molecules-atoms"] = "unselect all atoms of a molecule";
   DescriptionMap["verbose"] = "set verbosity level";
   DescriptionMap["verlet-integrate"] = "perform verlet integration of a given force file";
   DescriptionMap["version"] = "show version";
   // keys for values
-  DescriptionMap["atom-by-id"] = "index of an atom";
+  DescriptionMap["angle-x"] = "angle of a rotation around x axis";
+  DescriptionMap["angle-y"] = "angle of a rotation around y axis";
+  DescriptionMap["angle-z"] = "angle of a rotation around z axis";
   DescriptionMap["bin-output-file"] = "name of the bin output file";
   DescriptionMap["bin-end"] = "start of the last bin";
@@ -214,5 +284,4 @@
   DescriptionMap["MaxDistance"] = "maximum distance in space";
   DescriptionMap["molecule-by-id"] = "index of a molecule";
-  DescriptionMap["molecule-by-name"] = "name of a molecule";
   DescriptionMap["nonconvex-file"] = "filename of the non-convex envelope";
   DescriptionMap["order"] = "order of a discretization, dissection, ...";
@@ -220,5 +289,4 @@
   DescriptionMap["periodic"] = "system is constraint to periodic boundary conditions (y/n)";
   DescriptionMap["position"] = "position in R^3 space";
-  DescriptionMap["sphere-radius"] = "radius of tesselation sphere";
   DescriptionMap["start-step"] = "first or start step";
 
@@ -244,8 +312,7 @@
   ShortFormMap["nonconvex-envelope"] = "N";
 //  ShortFormMap["output"] = "o";
-  ShortFormMap["pair-correlation"] = "C";
+//  ShortFormMap["pair-correlation"] = "C";
   ShortFormMap["parse-xyz"] = "p";
   ShortFormMap["remove-atom"] = "r";
-  ShortFormMap["remove-sphere"] = "R";
   ShortFormMap["repeat-box"] = "d";
   ShortFormMap["rotate-to-pas"] = "m";
@@ -258,5 +325,5 @@
   ShortFormMap["subgraph-dissect"] = "I";
   ShortFormMap["suspend-in-water"] = "u";
-  ShortFormMap["translate-mol"] = "t";
+  ShortFormMap["translate-atoms"] = "t";
   ShortFormMap["verbose"] = "v";
   ShortFormMap["verlet-integrate"] = "P";
@@ -264,89 +331,135 @@
 
   // value types for the actions
-  TypeMap["add-atom"] = Element;
-  TypeMap["bond-file"] = String;
-  TypeMap["bond-table"] = String;
-  TypeMap["boundary"] = Vector;
-  TypeMap["center-in-box"] = Box;
-  TypeMap["change-box"] = Box;
-  TypeMap["change-element"] = Element;
-  TypeMap["change-molname"] = String;
-  TypeMap["convex-envelope"] = Molecule;
-  TypeMap["default-molname"] = String;
-  TypeMap["depth-first-search"] = Double;
-  TypeMap["element-db"] = String;
-  TypeMap["fastparsing"] = Boolean;
-  TypeMap["fill-molecule"] = String;
-  TypeMap["fragment-mol"] = String;
-  TypeMap["input"] = String;
-  TypeMap["linear-interpolate"] = String;
-  TypeMap["molecular-volume"] = Molecule;
-  TypeMap["nonconvex-envelope"] = Molecule;
-  TypeMap["output"] = None;
-  TypeMap["parse-xyz"] = String;
-  TypeMap["pair-correlation"] = String;
-  TypeMap["principal-axis-system"] = Molecule;
-  TypeMap["remove-atom"] = Atom;
-  TypeMap["remove-sphere"] = Double;
-  TypeMap["repeat-box"] = Vector;
-  TypeMap["rotate-to-pas"] = Molecule;
-  TypeMap["save-adjacency"] = String;
-  TypeMap["save-bonds"] = String;
-  TypeMap["save-temperature"] = String;
-  TypeMap["scale-box"] = Vector;
-  TypeMap["set-basis"] = String;
-  TypeMap["set-output"] = ListOfString;
-  TypeMap["subgraph-dissect"] = None;
-  TypeMap["suspend-in-water"] = Double;
-  TypeMap["translate-mol"] = Vector;
-  TypeMap["verlet-integrate"] = String;
-  TypeMap["verbose"] = Integer;
+  TypeMap["add-atom"] = &typeid(const element);
+  TypeMap["bond-file"] = &typeid(std::string);
+  TypeMap["bond-table"] = &typeid(std::string);
+  TypeMap["boundary"] = &typeid(VectorValue);
+  TypeMap["center-in-box"] = &typeid(BoxValue);
+  TypeMap["change-box"] = &typeid(BoxValue);
+  TypeMap["change-element"] = &typeid(const element);
+  TypeMap["change-molname"] = &typeid(std::string);
+  TypeMap["clear-atom-selection"] = &typeid(void);
+  TypeMap["clear-molecule-selection"] = &typeid(void);
+  TypeMap["convex-envelope"] = &typeid(void);
+  TypeMap["default-molname"] = &typeid(std::string);
+  TypeMap["depth-first-search"] = &typeid(double);
+  TypeMap["element-db"] = &typeid(std::string);
+  TypeMap["fastparsing"] = &typeid(bool);
+  TypeMap["fill-molecule"] = &typeid(std::string);
+  TypeMap["fragment-mol"] = &typeid(std::string);
+  TypeMap["input"] = &typeid(std::string);
+  TypeMap["linear-interpolate"] = &typeid(std::string);
+  TypeMap["molecular-volume"] = &typeid(molecule);
+  TypeMap["nonconvex-envelope"] = &typeid(double);
+  TypeMap["output"] = &typeid(void);
+  TypeMap["parse-xyz"] = &typeid(std::string);
+  TypeMap["pair-correlation"] = &typeid(void);
+  TypeMap["point-correlation"] = &typeid(void);
+  TypeMap["principal-axis-system"] = &typeid(void);
+  TypeMap["redo"] = &typeid(void);
+  TypeMap["remove-atom"] = &typeid(void);
+  TypeMap["repeat-box"] = &typeid(VectorValue);
+  TypeMap["rotate-origin"] = &typeid(double);
+  TypeMap["rotate-self"] = &typeid(double);
+  TypeMap["rotate-to-pas"] = &typeid(VectorValue);
+  TypeMap["save-adjacency"] = &typeid(std::string);
+  TypeMap["save-bonds"] = &typeid(std::string);
+  TypeMap["save-temperature"] = &typeid(std::string);
+  TypeMap["scale-box"] = &typeid(VectorValue);
+  TypeMap["select-all-atoms"] = &typeid(void);
+  TypeMap["select-all-molecules"] = &typeid(void);
+  TypeMap["select-atom-by-element"] = &typeid(const element);
+  TypeMap["select-atom-by-id"] = &typeid(atom);
+  TypeMap["select-atoms-inside-cuboid"] = &typeid(VectorValue);
+  TypeMap["select-atoms-inside-sphere"] = &typeid(double);
+  TypeMap["select-molecule-by-formula"] = &typeid(std::string);
+  TypeMap["select-molecule-by-id"] = &typeid(molecule);
+  TypeMap["select-molecule-of-atom"] = &typeid(atom);
+  TypeMap["select-molecules-atoms"] = &typeid(molecule);
+  TypeMap["set-basis"] = &typeid(std::string);
+  TypeMap["set-output"] = &typeid(std::vector<std::string>);
+  TypeMap["subgraph-dissect"] = &typeid(void);
+  TypeMap["surface-correlation"] = &typeid(void);
+  TypeMap["suspend-in-water"] = &typeid(double);
+  TypeMap["translate-atoms"] = &typeid(VectorValue);
+  TypeMap["undo"] = &typeid(void);
+  TypeMap["unselect-all-atoms"] = &typeid(void);
+  TypeMap["unselect-all-molecules"] = &typeid(void);
+  TypeMap["unselect-atom-by-element"] = &typeid(const element);
+  TypeMap["unselect-atom-by-id"] = &typeid(atom);
+  TypeMap["unselect-atoms-inside-cuboid"] = &typeid(VectorValue);
+  TypeMap["unselect-atoms-inside-sphere"] = &typeid(double);
+  TypeMap["unselect-molecule-by-formula"] = &typeid(std::string);
+  TypeMap["unselect-molecule-by-id"] = &typeid(molecule);
+  TypeMap["unselect-molecule-of-atom"] = &typeid(atom);
+  TypeMap["unselect-molecules-atoms"] = &typeid(molecule);
+  TypeMap["verlet-integrate"] = &typeid(std::string);
+  TypeMap["verbose"] = &typeid(int);
 
   // value types for the values
-  TypeMap["atom-by-id"] = Atom;
-  TypeMap["bin-output-file"] = String;
-  TypeMap["bin-end"] = Double;
-  TypeMap["bin-start"] = Double;
-  TypeMap["bin-width"] = Double;
-  TypeMap["convex-file"] = String;
-  TypeMap["distance"] = Double;
-  TypeMap["distances"] = Vector;
-  TypeMap["DoRotate"] = Boolean;
-  TypeMap["element"] = Element;
-  TypeMap["elements"] = ListOfElements;
-  TypeMap["end-step"] = Integer;
-  TypeMap["id-mapping"] = Boolean;
-  TypeMap["length"] = Double;
-  TypeMap["lengths"] = Vector;
-  TypeMap["MaxDistance"] = Double;
-  TypeMap["molecule-by-id"] = Molecule;
-  TypeMap["molecule-by-name"] = Molecule;
-  TypeMap["nonconvex-file"] = String;
-  TypeMap["order"] = Integer;
-  TypeMap["output-file"] = String;
-  TypeMap["periodic"] = Boolean;
-  TypeMap["position"] = Vector;
-  TypeMap["sphere-radius"] = Double;
-  TypeMap["start-step"] = Integer;
+  TypeMap["angle-x"] = &typeid(double);
+  TypeMap["angle-y"] = &typeid(double);
+  TypeMap["angle-z"] = &typeid(double);
+  TypeMap["bin-output-file"] = &typeid(std::string);
+  TypeMap["bin-end"] = &typeid(double);
+  TypeMap["bin-start"] = &typeid(double);
+  TypeMap["bin-width"] = &typeid(double);
+  TypeMap["convex-file"] = &typeid(std::string);
+  TypeMap["distance"] = &typeid(double);
+  TypeMap["distances"] = &typeid(VectorValue);
+  TypeMap["DoRotate"] = &typeid(bool);
+  TypeMap["element"] = &typeid(const element);
+  TypeMap["elements"] = &typeid(std::vector<const element *>);
+  TypeMap["end-step"] = &typeid(int);
+  TypeMap["id-mapping"] = &typeid(bool);
+  TypeMap["length"] = &typeid(double);
+  TypeMap["lengths"] = &typeid(VectorValue);
+  TypeMap["MaxDistance"] = &typeid(double);
+  TypeMap["molecule-by-id"] = &typeid(molecule);
+  TypeMap["nonconvex-file"] = &typeid(std::string);
+  TypeMap["order"] = &typeid(int);
+  TypeMap["output-file"] = &typeid(std::string);
+  TypeMap["periodic"] = &typeid(bool);
+  TypeMap["position"] = &typeid(VectorValue);
+  TypeMap["start-step"] = &typeid(int);
+
+  TypeEnumMap[&typeid(void)] = None;
+  TypeEnumMap[&typeid(bool)] = Boolean;
+  TypeEnumMap[&typeid(int)] = Integer;
+  TypeEnumMap[&typeid(std::vector<int>)] = ListOfIntegers;
+  TypeEnumMap[&typeid(double)] = Double;
+  TypeEnumMap[&typeid(std::vector<double>)] = ListOfDoubles;
+  TypeEnumMap[&typeid(std::string)] = String;
+  TypeEnumMap[&typeid(std::vector<std::string>)] = ListOfStrings;
+  TypeEnumMap[&typeid(VectorValue)] = Vector;
+  TypeEnumMap[&typeid(std::vector<VectorValue>)] = ListOfVectors;
+  TypeEnumMap[&typeid(BoxValue)] = Box;
+  TypeEnumMap[&typeid(molecule)] = Molecule;
+  TypeEnumMap[&typeid(std::vector<molecule *>)] = ListOfMolecules;
+  TypeEnumMap[&typeid(atom)] = Atom;
+  TypeEnumMap[&typeid(std::vector<atom *>)] = ListOfAtoms;
+  TypeEnumMap[&typeid(const element)] = Element;
+  TypeEnumMap[&typeid(std::vector<const element *>)] = ListOfElements;
 
   // default values for any action that needs one (always string!)
-  DefaultValue["bin-width"] = "0.5";
-  DefaultValue["fastparsing"] = "0";
-  DefaultValue["atom-by-id"] = "-1";
-  DefaultValue["molecule-by-id"] = "-1";
-  DefaultValue["periodic"] = "0";
+  CurrentValue["bin-width"] = "0.5";
+  CurrentValue["fastparsing"] = "0";
+  CurrentValue["periodic"] = "0";
 
   // put action into each menu category
   MenuDescription["analysis"] = pair<std::string,std::string>("Analysis (pair correlation, volume)", "Analysis");
-  MenuDescription["atom"] = pair<std::string,std::string>("Edit atoms", "Edit atoms");
-  MenuDescription["command"] = pair<std::string,std::string>("Configuration", "Configuration");
+  MenuDescription["atom"] = pair<std::string,std::string>("Edit atoms", "Atoms");
+  MenuDescription["command"] = pair<std::string,std::string>("Configuration", "configuration options");
   MenuDescription["fragmentation"] = pair<std::string,std::string>("Fragmentation", "Fragmentation");
-  MenuDescription["molecule"] = pair<std::string,std::string>("Parse files into system", "Parse files");
-  MenuDescription["parser"] = pair<std::string,std::string>("Edit molecules (load, parse, save)", "Edit molecules");
-  MenuDescription["tesselation"] = pair<std::string,std::string>("Tesselate molecules", "Tesselate molecules");
-  MenuDescription["world"] = pair<std::string,std::string>("Edit world", "Edit world");
+  MenuDescription["molecule"] = pair<std::string,std::string>("Parse files into system", "Molecules");
+  MenuDescription["parser"] = pair<std::string,std::string>("Edit molecules (load, parse, save)", "Input/Output");
+  MenuDescription["selection"] = pair<std::string,std::string>("Select atoms/molecules", "Selection");
+  MenuDescription["tesselation"] = pair<std::string,std::string>("Tesselate molecules", "Tesselation");
+  MenuDescription["world"] = pair<std::string,std::string>("Edit world", "Globals");
 
   MenuContainsActionMap.insert( pair<std::string, std::string> ("analysis", "molecular-volume") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("analysis", "pair-correlation") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("analysis", "point-correlation") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("analysis", "surface-correlation") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("analysis", "principal-axis-system") );
 
@@ -354,4 +467,5 @@
   MenuContainsActionMap.insert( pair<std::string, std::string> ("atom", "change-element") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("atom", "remove-atom") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("atom", "translate-atoms") );
 
   MenuContainsActionMap.insert( pair<std::string, std::string> ("command", "bond-table") );
@@ -369,4 +483,6 @@
   MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "fill-molecule") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "linear-interpolate") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "rotate-origin") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "rotate-self") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "rotate-to-pas") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "save-adjacency") );
@@ -374,9 +490,31 @@
   MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "save-temperature") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "suspend-in-water") );
-  MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "translate-mol") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("molecule", "verlet-integrate") );
 
   MenuContainsActionMap.insert( pair<std::string, std::string> ("parser", "parse-xyz") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("parser", "SaveXyz") );
+
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "clear-atom-selection") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "clear-molecule-selection") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-all-atoms") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-all-molecules") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-atom-by-element") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-atom-by-id") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-atoms-inside-cuboid") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-atoms-inside-sphere") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-molecule-by-id") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-molecule-by-formula") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-molecule-of-atom") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "select-molecules-atoms") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-all-atoms") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-all-molecules") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-atom-by-element") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-atom-by-id") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-atoms-inside-cuboid") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-atoms-inside-sphere") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-molecule-by-formula") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-molecule-by-id") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-molecule-of-atom") );
+  MenuContainsActionMap.insert( pair<std::string, std::string> ("selection", "unselect-molecules-atoms") );
 
   MenuContainsActionMap.insert( pair<std::string, std::string> ("tesselation", "convex-envelope") );
@@ -390,5 +528,4 @@
   MenuContainsActionMap.insert( pair<std::string, std::string> ("world", "input") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("world", "output") );
-  MenuContainsActionMap.insert( pair<std::string, std::string> ("world", "remove-sphere") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("world", "repeat-box") );
   MenuContainsActionMap.insert( pair<std::string, std::string> ("world", "scale-box") );
@@ -407,5 +544,7 @@
 	generic.insert("change-box");
 //  generic.insert("change-molname");
-	generic.insert("change-element");
+  generic.insert("change-element");
+  generic.insert("clear-atom-selection");
+  generic.insert("clear-molecule-selection");
   generic.insert("convex-envelope");
 	generic.insert("default-molname");
@@ -423,8 +562,11 @@
 	generic.insert("pair-correlation");
 	generic.insert("parse-xyz");
+  generic.insert("point-correlation");
 //  generic.insert("principal-axis-system");
+  generic.insert("redo");
   generic.insert("remove-atom");
-  generic.insert("remove-sphere");
   generic.insert("repeat-box");
+  generic.insert("rotate-origin");
+  generic.insert("rotate-self");
   generic.insert("rotate-to-pas");
 	generic.insert("save-adjacency");
@@ -432,9 +574,31 @@
   generic.insert("save-temperature");
   generic.insert("scale-box");
+  generic.insert("select-all-atoms");
+  generic.insert("select-all-molecules");
+  generic.insert("select-atom-by-element");
+  generic.insert("select-atom-by-id");
+  generic.insert("select-atoms-inside-cuboid");
+  generic.insert("select-atoms-inside-sphere");
+  generic.insert("select-molecule-by-id");
+  generic.insert("select-molecule-by-formula");
+  generic.insert("select-molecule-of-atom");
+  generic.insert("select-molecules-atoms");
   generic.insert("set-basis");
   generic.insert("set-output");
 	generic.insert("subgraph-dissect");
+  generic.insert("surface-correlation");
   generic.insert("suspend-in-water");
-  generic.insert("translate-mol");
+  generic.insert("translate-atoms");
+  generic.insert("undo");
+  generic.insert("unselect-all-atoms");
+  generic.insert("unselect-all-molecules");
+  generic.insert("unselect-atom-by-element");
+  generic.insert("unselect-atom-by-id");
+  generic.insert("unselect-atoms-inside-cuboid");
+  generic.insert("unselect-atoms-inside-sphere");
+  generic.insert("unselect-molecule-by-formula");
+  generic.insert("unselect-molecule-by-id");
+  generic.insert("unselect-molecule-of-atom");
+  generic.insert("unselect-molecules-atoms");
 	generic.insert("verbose");
   generic.insert("verlet-integrate");
@@ -443,31 +607,30 @@
     // positional arguments
   generic.insert("input");
-  inputfile.insert("input");
 
     // hidden arguments
-  generic.insert("atom-by-id");
-  generic.insert("bin-end");
-  generic.insert("bin-output-file");
-  generic.insert("bin-start");
-  generic.insert("bin-width");
-  generic.insert("convex-file");
-  generic.insert("distance");
-  generic.insert("DoRotate");
-  generic.insert("distances");
-  generic.insert("element");
-  generic.insert("elements");
-  generic.insert("end-step");
-  generic.insert("id-mapping");
-  generic.insert("lengths");
-  generic.insert("MaxDistance");
-  generic.insert("molecule-by-id");
-  generic.insert("molecule-by-name");
-  generic.insert("nonconvex-file");
-  generic.insert("order");
-  generic.insert("output-file");
-  generic.insert("periodic");
-  generic.insert("position");
-  generic.insert("sphere-radius");
-  generic.insert("start-step");
+  hidden.insert("angle-x");
+  hidden.insert("angle-y");
+  hidden.insert("angle-z");
+  hidden.insert("bin-end");
+  hidden.insert("bin-output-file");
+  hidden.insert("bin-start");
+  hidden.insert("bin-width");
+  hidden.insert("convex-file");
+  hidden.insert("distance");
+  hidden.insert("DoRotate");
+  hidden.insert("distances");
+  hidden.insert("element");
+  hidden.insert("elements");
+  hidden.insert("end-step");
+  hidden.insert("id-mapping");
+  hidden.insert("lengths");
+  hidden.insert("MaxDistance");
+  hidden.insert("molecule-by-id");
+  hidden.insert("nonconvex-file");
+  hidden.insert("order");
+  hidden.insert("output-file");
+  hidden.insert("periodic");
+  hidden.insert("position");
+  hidden.insert("start-step");
 }
 
